# -*- coding: utf-8 -*-

import re
import sys
import urllib2

from webapi.webStore.Aliexpress import Aliexpress
from webapi.webStore.Aliexpress.conf import STORE_DICT_LIST, STATIC_DETAIL

reload(sys)
sys.setdefaultencoding('utf-8')

def get_internel_product_dict(sku):
    """
    将内部系统sku，转换为速卖通要求的字典
    :param sku: sku值
    :return:返回系统内部将sku得一些值进行封装得dict
    """
    #
    # ii = InternalProducts.objects.get(sku = sku)
    # purchase_price = float(ii.purchase_price or 1)
    #
    # real_gross_weight = float(ii.real_gross_weight or 1)
    #
    # currenty_US_CN = 6.1
    # if purchase_price > float(2):
    #     purchase_price = (purchase_price + 0.0905 * real_gross_weight + 8)*1.06*1.3/currenty_US_CN
    # else:
    #     return {'status' : False, 'error_message' : 'Please set your purchase price.', 'sku' : sku}
    #
    # iimm = ii.internal_product_map.first()
    #
    # if iimm:
    #     mm = iimm.market_product
    #
    #     # 因为我这里只上传一个图片，所以值用medium_image就可以了，这里的这个图片列表就不需要
    #     image_url_list = eval(mm.image_list or '[]')
    #
    #     medium_image = mm.medium_image
    #     title = mm.title
    #     for brand_key in BRAND_LIST:
    #         try:
    #             title = re.sub(str(brand_key), '',title, flags=re.I)
    #         except Exception as e:
    #             print 'error:',brand_key,str(e)
    #
    #     description = mm.description.replace('\n','').replace('\t','')
    #     detail_dict = eval(mm.detail or '{}')
    # else:
    #     return {'status' : False, 'error_message' : 'Please upload to other channel.', 'sku' : sku}
    #
    # detail_str = ''
    #
    #
    #
    #
    # for key in detail_dict:
    #     detail_str = detail_str + '<tr><td>' + str(key) + '</td><td>' + str(detail_dict.get(key, '')) + '</td></tr>'
    #
    # detail = '<br>' + description + '<br>' + '<table border="1">' + detail_str + '</table><br>'
    #
    #
    # aeopAeProductSKUs = [{"skuPrice" :str(purchase_price),"currencyCode" : "USD", "skuCode" : str(sku), "skuStock" :"true", "aeopSKUProperty" : []}]
    #
    # internel_product_dict = {
    #         'detail' : detail,
    #         'aeopAeProductPropertys' : '[{ "attrValueId": 124, "attrNameId": 10 }]',
    #         'aeopAeProductSKUs' : str(aeopAeProductSKUs),
    #         'imageURLs' : image_url_list,
    #         'productPrice' : str(purchase_price),
    #         'subject' : title,
    # }
    internel_product_dict = None
    return {'status' : True, 'product' : internel_product_dict}

def get_alexpress_url_list(a, image_url_list, groupId=None):
    image_url_list_return = []
    for image_url in image_url_list:
        try:
            image_data = urllib2.urlopen(image_url, timeout=5).read()
        except Exception as e:
            return {'status' : False, 'error_message' : 'Download image error:' +  str(e), 'image_url' : image_url}

        temp_dict = {'fileName' : image_url.split('/')[-1]}
        if groupId:
            temp_dict['groupId'] =  groupId

        upload_image_result = a.upload_image(image_data,**temp_dict)
        if upload_image_result.get('success', False):
            image_url_list_return.append(upload_image_result['photobankUrl'])

            with open('image_aliexpress.csv', 'a') as f:
                f.write(image_url + '\t' + upload_image_result['photobankUrl'] + '\n')
            # return {'status' : True, 'image_url' : upload_image_result['url'], 'file_name' : upload_image_result['srcFileName']}
        else:
            # return {'status' : False, 'error_code' : upload_image_result.get('error_code', 'error_code'), 'error_message' : upload_image_result.get('error_message', 'error_message'), 'image_url' : image_url}
            print {'status' : False, 'error_code' : upload_image_result.get('error_code', 'error_code'), 'error_message' : upload_image_result.get('error_message', 'error_message'), 'image_url' : image_url}
    return {'status' : True, 'image_url' : image_url_list_return}

def get_alexpress_url(a, image_url):
    try:
        image_data = urllib2.urlopen(image_url, timeout=5).read()
    except Exception as e:
        return {'status' : False, 'error_message' : 'Download image error:' +  str(e), 'image_url' : image_url}

    temp_dict = {'srcFileName' : image_url.split('/')[-1]}

    upload_image_result = a.upload_temp_image(image_data,**temp_dict)
    if upload_image_result.get('success', False):
        return {'status' : True, 'image_url' : upload_image_result['url'], 'file_name' : upload_image_result['srcFileName']}
    else:
        return {'status' : False, 'error_code' : upload_image_result.get('error_code', 'error_code'), 'error_message' : upload_image_result.get('error_message', 'error_message'), 'image_url' : image_url}


def get_products_dict_by_sku_list(aliexpress, sku_url_list):
    """
    这里需要配置产品分组，服务模板，运费模板，品类ID，产品单位
    :param aliexpress:
    :param sku_url_list:
    :return:
    """

    image_group_id = '601649106'
    product_group_id = '505265170'
    freight_template_id = '703869419'
    promise_template_id = '0'
    category_id = '200001423'
    product_unit = '100000015'

    product_upload_default = {
        'groupId' : product_group_id,
        'freightTemplateId' : freight_template_id,
        'promiseTemplateId' : promise_template_id,
        'categoryId' : category_id,
        'productUnit' : product_unit,


        'deliveryTime' : '5',
        'packageType' : '0',
        'lotNum' : '1',
        'packageLength' : '20',
        'packageWidth' : '10',
        'packageHeight' : '10',
        'grossWeight' : '0.3',
        'isPackSell' : '0',
        'baseUnit' : '1',
        'addUnit' : '2',
        'addWeight' : '0.01',
        'wsValidNum' : '30',
        'bulkOrder' : '2',
        'bulkDiscount' : '2',
        'reduceStrategy' : 'payment_success_deduct',
        'currencyCode' : 'USD',
    }
    products_dict = {}

    for key in sku_url_list:
        try:
            print 'get sku product dict:', key
            internel_product_dict_result = get_internel_product_dict(sku=key)
            if internel_product_dict_result['status']:
                internel_product_dict = internel_product_dict_result['product']
            else:
                products_dict[str(key)] = internel_product_dict_result
                continue
            internel_product_dict.update(product_upload_default)

            inter_product_url_result = get_alexpress_url_list(aliexpress, internel_product_dict['imageURLs'], groupId=image_group_id)
            if inter_product_url_result['status']:
                image_url = inter_product_url_result['image_url']
                image_url_str = ''
                for i in image_url:
                    try:
                        image_url_str += '<img src="' + i + '"><br>'
                    except Exception as e:
                        continue
            else:
                products_dict[str(key)] = inter_product_url_result
                continue
            internel_product_dict['imageURLs'] = ';'.join(image_url[0:6])

            internel_product_dict['detail'] = internel_product_dict['detail'] + '<br><b>Image</b><br>' + image_url_str + STATIC_DETAIL
            products_dict[str(key)] = {'status' : True, 'product' : internel_product_dict, 'sku' : key}
        except Exception as e:
            products_dict[str(key)] = {'status' : False, 'sku' : key, 'error_message' : str(e)}
            continue

    return products_dict


def upload_product_bulk():
    sku_url_list = ['D06GPST27001']

    store_list = STORE_DICT_LIST
    store_name = 'starmerx_001'
    aliexpress = Aliexpress(app_key=store_list[store_name]['app_key'], secret_key=store_list[store_name]['secret_key'], refresh_token=store_list[store_name]['refresh_token'], access_token=store_list[store_name]['access_token'], code= store_list[store_name]['code'])

    product_lists = get_products_dict_by_sku_list(aliexpress, sku_url_list=sku_url_list)

    result_list = {}
    for key in product_lists:
        print 'start post product to aliexpress:', key
        if product_lists[key]['status']:
            try:
                product_result = aliexpress.post_aliexpress_product(**product_lists[key]['product'])
                print 'upload sku:', key, ' result:', product_result
                if product_result.get('success', False):
                    result_list[key] = {'product_id' : product_result.get('productId', 'productId'), 'status' : product_result.get('success', False), 'sku' : key}
                else:
                    result_list[key] = {'status' : False, 'error_code' : product_result.get('error_code', 'error_code'), 'error_message' : product_result.get('error_message', 'error_message')}
            except Exception as e:
                result_list[key] = {'status' : False, 'error_code' : str(e), 'error_message' : str(e)}

        else:
            result_list[key] = product_lists[key]



    with open('bulk_upload.csv', 'a') as f:
        for key in result_list:
            f.write(str(key) + '\t' + str(result_list.get(key, '')) + '\n')

    return result_list





def get_product_csv():
    with open('ae_pro.csv', 'w') as f:
        sku_list = []
        for sku in sku_list:
            internel_product_dict = get_internel_product_dict(sku=sku)
            internel_product_dict.update()



if __name__=='__main__':


    # DJANGO_SETTINGS_MODULE
    a = upload_product_bulk()
    print a


